unit main;

interface

uses
  Windows, Classes, Sysutils,Controls, Forms, StdCtrls, ExtCtrls,
  SHDocVw, OleCtrls, MSHTTPPost;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    eURL: TEdit;
    bGo: TButton;
    cXMLCommand: TComboBox;
    WebBrowser1: TWebBrowser;
    Splitter1: TSplitter;
    Panel2: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    Memo1: TMemo;
    procedure FormShow(Sender: TObject);
    procedure cXMLCommandChange(Sender: TObject);
    procedure bGoClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormShow(Sender: TObject);
begin
  cXMLCommand.ItemIndex := 0;
  cXMLCommandChange(self);
end;

procedure TForm1.cXMLCommandChange(Sender: TObject);
var
  Filename : string;
begin
  FileName := ExtractFilePath(Application.ExeName)+cXMLCommand.Text+'.x';
  Memo1.Lines.LoadFromFile(FileName);
end;

function ChangeToken(Source,Token,ToStr: string): string;
var
  Dest : string;
  TokenPos : integer;
begin
    Dest := Source;
    repeat
      TokenPos := pos(Token,Dest);
      if TokenPos <> 0 then
      begin
         delete(Dest,TokenPos,length(Token));
         insert(ToStr,Dest,Tokenpos);
      end;
    until Tokenpos = 0;
    result := Dest;
end;

function AddSec(Dt: TDateTime; Sec: extended): TDateTime;
begin
  result :=  DT + Sec / (24 * 60 * 60)
end;

function GetTimeZoneBias: Integer;
var
  TimeZoneInfo: TTimeZoneInformation;
begin
  case GetTimeZoneInformation(TimeZoneInfo) of
  TIME_ZONE_ID_STANDARD: Result := TimeZoneInfo.Bias + TimeZoneInfo.StandardBias;
  TIME_ZONE_ID_DAYLIGHT: Result := TimeZoneInfo.Bias + TimeZoneInfo.DaylightBias;
  else
    Result := 0;
  end;
end;

function dDateTimeToXMLTime(Value: TDateTime; ApplyLocalBias: Boolean = True): WideString;
const
  Neg: array[Boolean] of string=  ('+', '-');
var
  Bias: Integer;
begin
  Result := FormatDateTime('yyyy''-''mm''-''dd''T''hh'':''nn'':''ss''.''zzz', Value); { Do not localize }
  Bias := GetTimeZoneBias;
  if (Bias <> 0) and ApplyLocalBias then
  begin
    Result := Format('%s%s%.2d:%.2d', [Result, Neg[Bias > 0],                         { Do not localize }
                                       Abs(Bias) div 60,
                                       Abs(Bias) mod 60]);
  end else
    Result := Result + 'Z'; { Do not localize }
end;


const
  SHB1 = '<?xml version="1.0" encoding="utf-8"?>';
  SHB2 = '<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">';
  SHB3 = '<SOAP-ENV:Body>';
  //... XML Command
  SHE1 = '</SOAP-ENV:Body>';
  SHE2 = '</SOAP-ENV:Envelope>';

procedure TForm1.bGoClick(Sender: TObject);
var
  SoapAction : string;
  Request    : TStringStream;
  Response   : TStringStream;
  SOAPText   : string;
  SList      : TStringlist;
  FileName   : String;
  OldC       : TCursor;
begin
  Oldc := Screen.Cursor;
  SoapAction := 'http://opcfoundation.org/webservices/XMLDA/1.0/'+cXMLCommand.Text;
  SOAPText := Memo1.Lines.text;
  SOAPText := ChangeToken(SOAPText,'#now+1#',dDateTimeToXMLTime(AddSec(now,1)));
  SOAPText := ChangeToken(SOAPText,'#now#',dDateTimeToXMLTime(now));
  SOAPText := ChangeToken(SOAPText,'#now-1#',dDateTimeToXMLTime(AddSec(now,-1)));
  SOAPText := ChangeToken(SOAPText,'#now+1m#',dDateTimeToXMLTime(AddSec(now,60)));
  Request  := TStringStream.Create(SHB1+SHB2+SHB3+SOAPText+SHE1+SHE2);
  Response := TStringStream.Create('');
  SList    := TStringlist.create;
  try
    Screen.Cursor := crHourGlass;
    PostData(eUrl.Text,'','','',SoapAction,Request,Response);
    Response.Position := 0;
    SList.LoadFromStream(Response);  // copy response to stringlist
    FileName := ExtractFilePath(Application.ExeName)+'Response.xml';
    SList.SaveToFile(FileName);
    WebBrowser1.Navigate(WideString(FileName));
  finally
    Request.Free;
    Response.Free;
    SList.Free;
    Screen.Cursor := OldC;
  end;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_F9 then
    bGoClick(self);
end;

end.
